#!/usr/bin/python

import os,time,commands,re,string,sys,socket
from ConfigParser import ConfigParser
import urllib
import webbrowser

CDS=['cd1-sourcecast-4.5.1.52.i386-redhat-es3.tar.gz','cd2-sourcecast-4.5.1.52.i386-redhat-es3.tar.gz']
__doc__= """
****
Installing CollabNet Enterprise Edition. You can review the license terms and conditions you accepted in the file LICENSE.txt located in the folder where you ran the setup for CollabNet Enterprise Edition. Please visit http://open.collab.net for more information about this product and to get support. To know more about CollabNet visit http://www.collab.net.

***

"""
__version__ = '1.0'

SITE_OPTION_FILE ="conf/sample-site-options.conf"
REDIRECT=" |tee"

class SetUp:
    
    def __init__(self,argv):
	cwd = os.getcwd()
	#self.installer_path ="/u1/sourcecast"
	if not os.path.exists('onsite.conf'):
	   print "Conf File Missing, onsite.conf"
	   sys.exit(0)
	print __doc__

    def start(self):
	self.read_conf()
	cwd = os.getcwd()
	if os.path.exists(os.path.join(cwd, 'onsite-scripts')):	
	   os.chdir(os.path.join(cwd, 'onsite-scripts'))
	   self.out("\nDownloading the open-source packages and source to build. This may take a few minutes.")
	   cmd = './download.py </dev/null %s %s/download.log 2>&1' %(REDIRECT,self.log_path)
	   ret = self.execute_cmd(cmd)
	   if ret[0]== 0:
             cmd = "ls 0*"

             ret = self.execute_cmd(cmd)
             if ret[0] ==0:
                scripts = re.split("\n", ret[1])
		self.out("\nInstalling the non-CEE packages, takes an hour to build and install all the rpms")
                for each in scripts:
		     self.out("\n\nInstalling %s..." %each)
                     cmd = "./%s </dev/null %s %s/%s.log" %(each,REDIRECT,self.log_path,each)
                     ret = self.execute_cmd(cmd)
		     self.out(ret[1])
	   os.chdir(cwd)
	   if os.path.exists('onsite-environment_check.sh'):
	      self.out("\nChecking the Environment ...")
	      cmd = "./onsite-environment_check.sh %s %s/onsite-environment_check.log 2>&1" %(REDIRECT,self.log_path)
	      ret = self.execute_cmd(cmd)
	      self.out(ret[1])
	      if ret[0] ==0 :
   	         if not re.match("Your SourceCast Environment is not Up-to-Date", ret[1]):
	   	    self.out("Installing the CEE packages. This may take 20 to 30 minutes.")
		    if os.path.exists('install-sourcecast.sh'):
		       self.out("Installation Path : %s" %self.installer_path)
	               cmd = "./install-sourcecast.sh -n -i -d %s >%s/install-i.log 2>&1" %(self.installer_path,self.log_path)
                       self.out(cmd)
	               ret = self.execute_cmd(cmd)
                       self.out(ret)
                       if ret[0] != 0:
                          self.out("Error : Installation Failed \n check for the logs in %s" %self.log_path)
		          sys.exit(1)      
		       else:
			  if re.match("Operations successful", ret[1]):
                             self.out("Error : Installation Failed while installing Collabnet packages\n check for the logs in %s" %self.log_path)
                             sys.exit(1)
		       self.out("Setting the CEE installer setup.")
		       cmd = "./onsite-scripts/move_packages.py %s </dev/null %s %s/move_packages.log 2>&1" %(self.installer_path,REDIRECT,self.log_path)
		       ret = self.execute_cmd(cmd)
                       self.out("Creating the runtime environment.")
		       	      
		       cmd = "./install-sourcecast.sh -n -r -d %s >%s/install-r.log 2>&1" %(self.installer_path,self.log_path)
                       ret = self.execute_cmd(cmd)
	               if ret[0] == 0:
                          if re.match("Operations successful", ret[1]):
                             self.out("Error : Installation Failed while creating runtime \n check for the logs in %s" %self.log_path)
                             sys.exit(1)

	  	          self.out("Bootstrapping the data")
		          cmd = "./bootstrap-data.sh -n -s </dev/null > %s/bootstrap.log 2>&1" %(self.log_path)
		          ret = self.execute_cmd(cmd)
                          if ret[0] != 0:
                             self.out("Error : Bootstrap Failed \n check for the logs in %s" %self.log_path)
                             sys.exit(1)
                          else:
			     self.out("Installation completed successfully\n\n ")
                             url = "http://www.%s" %socket.gethostname()
                             self.out("To check your site, go to %s" %url)
                       else:
                          self.out("Error : Creating Runtime Failed \n check for the logs in %s" %self.log_path)
                          sys.exit(1)   
		 else:
		    self.out(ret[1])
	   else:
		self.out("environment-check.sh no such file")
	else :
            self.out("no such file or directory found")
	
    def copy_conf_files(self,source_path):
	 if os.path.exists('onsite.conf'):
            cmd = 'cp -f onsite.conf %s/onsite-scripts/onsite.conf'% source_path
            ret = self.execute_cmd(cmd)
            cmd = 'cp -f onsite.conf %s/onsite.conf'% source_path
            ret = self.execute_cmd(cmd)
         else:
            self.out("onsite.conf file not found")
            sys.exit(0)
	 if os.path.exists('site-options.conf'):
            cmd = 'cp -f  site-options.conf %s/conf/site-options.conf'% source_path
            ret = self.execute_cmd(cmd)
         else:
            self.out("site-options.conf file not found")
            sys.exit(0)

    def read_conf(self):
 	comp_ini = ConfigParser()
        comp_ini_path = 'onsite.conf' 
        comp_ini.read(comp_ini_path)
	self.tar_file=[]
	FLAG=1
	user =comp_ini.get('DEFAULT','username')
	passwd=comp_ini.get('DEFAULT','password')
	self.is_execute=comp_ini.get('DEFAULT','is_execute')
	self.is_verbose=comp_ini.get('DEFAULT','is_verbose')
	self.installer_path=comp_ini.get('DEFAULT','installer_path')
	self.log_path=comp_ini.get('DEFAULT','log_path')
        if (self.installer_path == ''): 
           self.out("Specify the installer path in onsite.conf and proceed with the setup.sh")
           sys.exit(1)
        if os.path.exists(self.installer_path):
           self.out("Path %s already exist, hence quiting")
           sys.exit(1)

        cmd ="grep DISTRIBUTION_DIR= site-options.conf |cut -f2 -d '='"
        ret =self.execute_cmd(cmd)
        if re.match(self.installer_path, ret[1]):
           print "Started CEE Installation Setup"
        else:
           print "Conflict in installation path among onsite.conf and site-options.conf, Please set correct path in both file and proceed with installation"
           sys.exit(0)

        cmd ="grep DOMAIN site-options.conf |cut -f2 -d '='"
        ret = self.execute_cmd(cmd)
        if ret[1] == '':
           self.out("Please set the DOMAIN name in site-options.conf and restart the setup")
           sys.exit(0)
        
        if not os.path.exists(self.log_path):
           try:
               os.makedirs(self.log_path)
           except Exception, e:
               self.out("Log directory : %s is not found or invalid" %self.log_path)
               sys.exit(1)
	self.tar_file=[ comp_ini.get('DEFAULT','build_tar_cd1'), comp_ini.get('DEFAULT','build_tar_cd2')]
 	for all in self.tar_file:
	    cwd = os.getcwd()
            file_name = all.split('/')[-1]

            if os.path.exists(file_name):
                #TODO: Need to check if there is a better way to get the file size
                http = urllib.urlopen(all)
		http_file_size =  http.info().dict['content-length']

                local_file_size = int(os.path.getsize(file_name))

                if http_file_size == local_file_size:
                   self.out("File already present, hence not downloading")
                   continue
                else:
                   self.out("Invalid filename, remove the file to download again")
                   cmd = 'rm -rf %s' % file_name
                   ret = self.execute_cmd(cmd)

#	    if not ((os.path.exists(os.path.join(cwd,CDS[0]))) or(os.path.exists(os.path.join(cwd,CDS[1]))):
	    if FLAG==1:
#	       cmd = "wget --help |grep http-passwd="
#               ret = self.execute_cmd(cmd)
	       if user == 'none' and passwd =='none':
                  cmd = "wget %s" %(all)
               else:
                  cmd = "wget --http-user=%s --http-passwd=%s %s" %(user, passwd, all)
	       self.out("Downloading the CEE tarball from %s" %all)
	       ret = self.execute_cmd(cmd)
	    
	       if ret[0] !=0:
	  	  self.out("Unable to download the file %s\n%s" %(all,ret[1]))
		  sys.exit(0)
	    else:
		self.out("TAR file already exist skipping")
	  
	if re.search('cd1',all):
	   cds = CDS[0]
	else:
	   cds =CDS[1]

	if re.search('cd2',CDS[1]):
	   dir1 = cds.split('cd2-')
  	   act_path = (dir1[1].split('.tar.gz'))

#	if not os.path.exists(act_path[0]):
        for all in CDS:
	    self.out("Untarring the tarball %s" %all)
            cmd = "tar xfz %s" %all
	    ret = self.execute_cmd(cmd)
  	    if ret[0] !=0:
	       self.out("Unable to untar the file %s\n%s" %(all,ret[1]))
#        else:
#           self.out("Found the installer already untared, hence not redoing it")

	if re.search('cd2',CDS[1]):
	   dir1 = cds.split('cd2-')
  	   act_path = (dir1[1].split('.tar.gz'))
	   self.copy_conf_files(act_path[0])
	   os.chdir(act_path[0])
	#   cmd = "echo DOMAIN=%s >> conf/site-options.conf" %socket.gethostname()
        #   self.out(cmd)
        #   ret = self.execute_cmd(cmd)
        #   self.out(ret)
	   cmd = "echo BDB_BINARIES_DIR=%s/dist/platform/i386-redhat-es3/BerkeleyDB-40/bin  >> conf/site-options.conf" %self.installer_path
           ret = self.execute_cmd(cmd)

    def execute_cmd(self,cmd):
        self.is_execute = 1
        #self.out("Command: %s" % cmd)
        if self.is_execute == 0:
           self.out("Execute is disabled: Hence NOT EXECUTING COMMAND")
           cmd = 'echo'

        ret = self.getcommandoutput_(cmd)
        return ret

    def out(self, msg):
        """Print msg if verbose is set."""
        if self.is_verbose != 0:
            print msg


    def getcommandoutput_(self,cmd):
        if os.name == 'nt':
           child = os.popen(cmd)
           data = child.read()
           err = child.close()
           if err:
              return 1,err
           return 0,data
        else:
           return commands.getstatusoutput(cmd)    		   
	    	
	
if __name__ == '__main__':

	tool = SetUp(sys.argv[0])
 		
	if len(sys.argv) >1:
            print "Usage : %s \n installer.py is the installer which takes input from two files \n\t onsite.conf \n\t site-options.conf\n Please make sure tokens are correctly filled and trigger installer.py " %sys.argv[0]
	    sys.exit(0)
	else :
           if os.path.exists("/tmp/install"): 
	      tool.start()
           else:
              print "Please go through the license terms before installing the software, please run setup.sh"
              sys.exit(0)
